* FlagViewer Source 
* (c) 1997, 98 by Matthew Mastracci

INCLUDE KEYDEFS.H

ASSEMBLE
	NIBASC /HPHP48-R/
RPL
::
* This is an internal program, so we don't need to check for specific 
* parameter types
  CK5

* Do the UFL check
	ID UFL?DoErr

	ONEONE FALSE
	{ 
		LAM FLT   ( Flag types- TRUE: System flags, FALSE: User flags )
		LAM FL0   ( This is the flag set title )
		LAM FL1		( Flag mappings [encoded in string] )
		LAM FL2   ( Flag clear text )
		LAM FL3   ( Flag set text )
		LAM CUR   ( Internal: current flag position )
		LAM TOP   ( Internal: top flag [on screen] position )
		LAM EXIT  ( Internal: exit flag )
	} BIND

* Bind our redraw and exit procedures (OK and Cancel)
	' ::
* Display title for flag selector using ROMPTR
		DOCLLCD
		LAM FL0
		ROMPTR 0E0 44
	;
	' :: TRUE ' LAM EXIT STO ;
	' :: TRUE ' LAM EXIT STO ;
	{ LAM DoDraw LAM DoCancel LAM DoOK } 
	BIND
		
	LAM DoDraw EVAL
  ' DispMenu.1
  ' ::
    kpNoShift #=casedrop
      ::
				DUP#<7 casedrpfls
        kcUpArrow			?CaseKeyDef
			  	:: TakeOver ;
				kcDownArrow		?CaseKeyDef
					:: TakeOver ;
        kcOn					?CaseKeyDef
				  :: TakeOver LAM DoCancel EVAL ;
        kcEnter				?CaseKeyDef
				  :: TakeOver LAM DoOK EVAL ;
        kcRightShift	#=casedrpfls
					DROP 'DoBadKeyT
      ;
    2DROP 'DoBadKeyT
  ;

* No standard keys 
	TrueTrue

* Our menu
	{
		{ "INFO" :: TakeOver ID INFO LAM DoDraw EVAL ; }
		NullMenuKey
		{ ROMPTR 0B0 86 :: TakeOver ; }
		NullMenuKey
    { "(AN(L" :: TakeOver LAM DoCancel EVAL ; }
    { "OK" :: TakeOver LAM DoOK EVAL ; }
  }

* First menu "row", no suspend
  ONEFALSE					
* Our exit condition (just a LAM)
  ' LAM EXIT
* Error handler
  ' ERRJMP
* Run it!
  ParOuterLoop

* Resize, clear and redraw display
  RECLAIMDISP				
  ClrDAsOK					

* Abandon our temporary environments
	ABND
	ABND
;
